; **********************************************************************
; *                                                                    *
; * Author   : Daniel Brall                                            *
; * Website  : http://www.bradan.eu/                                   *
; * E-Mail   : vectorizer@bradan.eu                                    *
; * Copyright: Daniel Brall                                            *
; *            All rights reserved!                                    *
; *                                                                    *
; * You are not allowed to modify and/or redistribute this sourcecode! *
; *                                                                    *
; **********************************************************************

XIncludeFile "vector.pbi"

Procedure ScanLinePoints(List Points.SVector(), List ScanLine.SVector(), scanLineY.d)
  Protected *previousPoint.SVector = #Null
  
  ClearList(ScanLine())
  
  ForEach Points()
    If *previousPoint <> #Null
      If *previousPoint\y >= scanLineY XOr Points()\y >= scanLineY
        AddElement(ScanLine())
        
        CopyStructure(@Points(), @ScanLine(), SVector)
        Sub(@ScanLine(), *previousPoint)
        Mul(@ScanLine(), (scanLineY - *previousPoint\y) / ScanLine()\y)
        Add(@ScanLine(), *previousPoint)
      EndIf
    EndIf
    *previousPoint = @Points()
  Next
EndProcedure

Procedure DrawPolygon(List Points.SVector(), offsetX.d, offsetY.d, scaleX.d, scaleY.d, color.i)
  Protected min.SVector
  Protected max.SVector
  Protected y.i
  Protected NewList ScanLine.SVector()
  Protected *first.SVector
  
  If ListSize(Points()) > 1
    FirstElement(Points())
    *first = @Points()
    
    LastElement(Points())
    AddElement(Points())
    CopyStructure(*first, @Points(), SVector)
    
    CopyStructure(*first, @min, SVector)
    CopyStructure(*first, @max, SVector)
    ForEach Points()
      If Points()\x < min\x
        min\x = Points()\x
      EndIf
      If Points()\y < min\y
        min\y = Points()\y
      EndIf
      
      If Points()\x > max\x
        max\x = Points()\x
      EndIf
      If Points()\y > max\y
        max\y = Points()\y
      EndIf
    Next
    
    For y = min\y To max\y
      ScanLinePoints(Points(), ScanLine(), y)
      SortStructuredList(ScanLine(), #PB_Sort_Ascending, OffsetOf(SVector\x), #PB_Sort_Double)
      
      ResetList(ScanLine())
      While NextElement(ScanLine())
        *first = @ScanLine()
        If NextElement(ScanLine())
          Box(*first\x * scaleX + offsetX, *first\y * scaleY + offsetY, (ScanLine()\x - *first\x) * scaleX, 1, color)
        Else
          Break
        EndIf
      Wend
    Next y
    
    LastElement(Points())
    DeleteElement(Points())
  EndIf
EndProcedure
; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 12
; Folding = -
; EnableXP